summaryrefslogtreecommitdiffstats
path: root/ci
diff options
context:
space:
mode:
authorTim Rozet <trozet@redhat.com>2016-12-06 12:58:55 -0500
committerTim Rozet <trozet@redhat.com>2016-12-08 21:52:32 -0500
commit58a098e08ec131338b0c29b902472c54b2a26168 (patch)
tree8fb5727e1511d1114cd5b60f0659d624105b4542 /ci
parent9131b0a81c22e713b4d4798d7ff32254be3b99e3 (diff)
Fixes and cleans up build/cache directory usage
Changes include: - Building is isolated to a .build directory that is git ignored - Caching is isolated to a .cache directory that is git ignored - Build scripts have been variablized, and relative paths have been removed - Unused files removed - build.sh, make file cleaned up - Fixed broken building of markupsafe and jinja2 packages - make clean-cache will remove the cache now - per item cleans are removed in place of simple clean .build now - includes fix for OSC issue with LP# 1642301 Change-Id: I42b8e4eb694bf0a2c398858814f8b73785931896 Signed-off-by: Tim Rozet <trozet@redhat.com>
Diffstat (limited to 'ci')
-rwxr-xr-xci/build.sh59
1 files changed, 29 insertions, 30 deletions
diff --git a/ci/build.sh b/ci/build.sh
index 0536cf9..3531a65 100755
--- a/ci/build.sh
+++ b/ci/build.sh
@@ -8,14 +8,14 @@
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################
-set -e
+set -xe
display_usage ()
{
cat << EOF
$0 Builds the Apex OPNFV Deployment Toolchain
-usage: $0 [ -c cache_dir ] -r release_name [ --iso | --rpms ]
+usage: $0 [ -c cache_dest_dir ] -r release_name [ --iso | --rpms ]
OPTIONS:
-c cache destination - destination to save tarball of cache
@@ -30,9 +30,9 @@ build -c file:///tmp/cache -r dev123
EOF
}
-BUILD_BASE=$(readlink -e ../build/)
+APEX_ROOT=$(dirname $(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd))
CACHE_DEST=""
-CACHE_DIR="cache"
+CACHE_DIR="${APEX_ROOT}/.cache"
CACHE_NAME="apex-cache"
MAKE_TARGETS="images"
REQUIRED_PKGS="rpm-build python-docutils"
@@ -89,11 +89,23 @@ parse_cmdline() {
}
run_make() {
- make $MAKE_ARGS -C ${BUILD_BASE} $1
+ make $MAKE_ARGS -C ${BUILD_DIRECTORY} $1
}
parse_cmdline "$@"
+if [ -z "$BUILD_DIRECTORY" ]; then
+ if [ -d "${APEX_ROOT}/build" ]; then
+ BUILD_DIRECTORY="${APEX_ROOT}/build"
+ else
+ echo "Cannot find build directory, please provide BUILD_DIRECTORY environment variable...exiting"
+ exit 1
+ fi
+elif [ ! -d "$BUILD_DIRECTORY" ]; then
+ echo "Provided build directory is invalid: ${BUILD_DIRECTORY} ...exiting"
+ exit 1
+fi
+
# Add release rpm to make targets if defined
MAKE_TARGETS+=$RELEASE_RPM
@@ -109,34 +121,27 @@ done
if [ -n "$RELEASE" ]; then MAKE_ARGS+="RELEASE=$RELEASE "; fi
-# Get the Old Cache
+# Get the Old Cache and build new cache history file
if [[ -n "$CACHE_DEST" && -n "$MAKE_TARGETS" ]]; then
echo "Retrieving Cache"
if [ -f $CACHE_DEST/${CACHE_NAME}.tgz ]; then
echo "Cache found at ${CACHE_DEST}/${CACHE_NAME}.tgz"
- rm -rf $BUILD_BASE/$CACHE_DIR
- echo "Unpacking Cache to $BUILD_BASE"
- tar -xvzf $CACHE_DEST/${CACHE_NAME}.tgz -C ${BUILD_BASE}
- if [ -f $BUILD_BASE/.cache ]; then
- echo "Rebuilding .cache file"
- if [ ! -d $BUILD_BASE/$CACHE_DIR ]; then
- mkdir $BUILD_BASE/$CACHE_DIR
- fi
- for i in $(ls $BUILD_BASE/$CACHE_DIR); do
- grep $i $BUILD_BASE/.cache >> $BUILD_BASE/$CACHE_DIR/.cache
- done
- fi
+ rm -rf $CACHE_DIR
+ mkdir $CACHE_DIR
+ echo "Unpacking Cache to ${CACHE_DIR}"
+ tar -xvzf ${CACHE_DEST}/${CACHE_NAME}.tgz -C ${CACHE_DIR}
echo "Cache contents after unpack:"
- ls -l $BUILD_BASE/$CACHE_DIR
+ ls -al ${CACHE_DIR}
else
echo "No Cache Found"
fi
fi
# Ensure the build cache dir exists
-if [ ! -d "$BUILD_BASE/$CACHE_DIR" ]; then
+if [ ! -d "$CACHE_DIR" ]; then
+ rm -rf ${CACHE_DIR}
echo "Creating Build Cache Directory"
- mkdir $BUILD_BASE/$CACHE_DIR
+ mkdir ${CACHE_DIR}
fi
# Conditionally execute RPM build checks if the specs change and target is not rpm or iso
@@ -186,17 +191,11 @@ echo "Build Complete"
# Build new Cache
if [ -n "$CACHE_DEST" ]; then
echo "Building Cache"
- ls -lh $BUILD_BASE/$CACHE_DIR/
+ ls -lah ${CACHE_DIR}
# ensure the destination exists
- if [ ! -d $CACHE_DEST ]; then mkdir -p $CACHE_DEST; fi
- # ensure a sub cache dir exists to mirror the build base for extraction
- if [ ! -d $BUILD_BASE/$CACHE_DIR/$CACHE_DIR/ ]; then mkdir -p $BUILD_BASE/$CACHE_DIR/$CACHE_DIR/; fi
- # move directly cached files to cache dir for future extraction
- for i in $(cat $BUILD_BASE/$CACHE_DIR/.cache | awk '{ print $2 }'); do
- if [ -f $i ]; then mv $i $BUILD_BASE/$CACHE_DIR/$CACHE_DIR/; fi
- done
+ mkdir -p ${CACHE_DEST}
# roll the cache tarball
- tar --atime-preserve --dereference -C ${BUILD_BASE}/$CACHE_DIR -caf $CACHE_DEST/${CACHE_NAME}.tgz .
+ tar --atime-preserve --dereference -caf ${CACHE_DEST}/${CACHE_NAME}.tgz -C ${CACHE_DIR} .
if [ -f "${CACHE_DEST}/${CACHE_NAME}.tgz" ]; then
echo "Cache Build Complete"
else